diff -u gforth-0.6.2-orig/Makefile.in gforth-0.6.2/Makefile.in
--- gforth-0.6.2-orig/Makefile.in	2003-08-25 09:57:49.000000000 +0200
+++ gforth-0.6.2/Makefile.in	2006-11-22 21:23:25.000000000 +0100
@@ -529,12 +529,12 @@
 		$(INSTALL_PROGRAM) -s gforth-itc$(EXE) $(bindir)/gforth-itc-$(VERSION)$(EXE)
 		(cd $(bindir) && $(LN_S) gforth-itc-$(VERSION)$(EXE) gforth-itc$(EXE))
 		$(INSTALL_PROGRAM) gforthmi $(bindir)/gforthmi-$(VERSION)
-		$(INSTALL_PROGRAM) vmgen $(bindir)/vmgen-$(VERSION)
+#		$(INSTALL_PROGRAM) vmgen $(bindir)/vmgen-$(VERSION)
 		$(INSTALL_PROGRAM) gforth-ditc $(libdir)/gforth/$(VERSION)
 		(cd $(bindir) && $(LN_S) gforthmi-$(VERSION) gforthmi)
-		(cd $(bindir) && $(LN_S) vmgen-$(VERSION) vmgen)
+#		(cd $(bindir) && $(LN_S) vmgen-$(VERSION) vmgen)
 		-$(INSTALL_DATA) $(srcdir)/doc/gforth.1 $(man1dir)
-		-for i in $(srcdir)/doc/gforth.info* $(srcdir)/doc/vmgen.info*; do $(INSTALL_DATA) $$i $(infodir); done
+		-for i in $(srcdir)/doc/gforth.info*; do $(INSTALL_DATA) $$i $(infodir); done
 		for i in $(FORTH_SRC) $(COMPAT) prim; do \
 			$(INSTALL_DATA) $(srcdir)/$$i $(datadir)/gforth/$(VERSION)/$$i; \
 		done
@@ -549,8 +549,8 @@
 		$(INSTALL_DATA) gforth.fi $(libdir)/gforth/$(VERSION)
 		$(INSTALL_DATA) install.TAGS $(datadir)/gforth/$(VERSION)/TAGS
 		$(RM) gforth.fi install.TAGS
-		$(INSTALL_INFO) --info-dir=$(infodir) $(infodir)/gforth.info
-		$(INSTALL_INFO) --info-dir=$(infodir) $(infodir)/vmgen.info
+#		$(INSTALL_INFO) --info-dir=$(infodir) $(infodir)/gforth.info
+#		$(INSTALL_INFO) --info-dir=$(infodir) $(infodir)/vmgen.info
 
 install-strip:	install
 
diff -ur gforth-0.6.2/configure gforth-0.6.2-patched/configure
--- gforth-0.6.2/configure	2003-08-25 10:03:42.000000000 +0200
+++ gforth-0.6.2-patched/configure	2006-11-07 20:26:00.000000000 +0100
@@ -3584,9 +3584,6 @@
 else
   LIBOBJS="$LIBOBJS ../arch/power/_sync_cache_range.$ac_objext"
 fi
-
-		#long long is broken on (at least) gcc-2.95.* for PPC
-		test x$ac_cv_sizeof_long_long = x && ac_cv_sizeof_long_long=0
 		;;
 	*)
 		{ echo "$as_me:$LINENO: WARNING: Using a generic machine description" >&5
diff -ur gforth-0.6.2/engine/Makefile.in gforth-0.6.2-patched/engine/Makefile.in
--- gforth-0.6.2/engine/Makefile.in	2003-08-06 15:36:36.000000000 +0200
+++ gforth-0.6.2-patched/engine/Makefile.in	2006-11-07 20:06:45.000000000 +0100
@@ -129,64 +129,64 @@
 	$(GCC) $(LDFLAGS) $(OBJECTS_FI) $(AOBJECTS) $(LDLIBS) -o $@
 
 engine.s:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -S $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS) $(CFLAGS2) $(ENGINE_FLAGS) -S $(srcdir)/engine.c
 
 engine.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/engine.c
 
 engine2.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DGFORTH_DEBUGGING -DENGINE=2 -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DGFORTH_DEBUGGING -DENGINE=2 -o $@ -c $(srcdir)/engine.c
 
 engine-native.o:$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DNO_IP -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DNO_IP -o $@ -c $(srcdir)/engine.c
 
 engine-native2.o:$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DNO_IP -DENGINE=2 -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DNO_IP -DENGINE=2 -o $@ -c $(srcdir)/engine.c
 
 engine-native3.o:$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DNO_IP -DENGINE=3 -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DNO_IP -DENGINE=3 -o $@ -c $(srcdir)/engine.c
 
 engine-fast.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -o $@ -c $(srcdir)/engine.c
 
 engine-fast2.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DENGINE=2 -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DENGINE=2 -o $@ -c $(srcdir)/engine.c
 
 engine-itc.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DINDIRECT_THREADED -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DINDIRECT_THREADED -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/engine.c
 
 engine-ditc.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DDOUBLY_INDIRECT -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DDOUBLY_INDIRECT -o $@ -c $(srcdir)/engine.c
 
 engine-prof.o:	$(ENGINE_DEPS)
-		$(GCC) $(CFLAGS2) $(ENGINE_FLAGS) -DVM_PROFILING -o $@ -c $(srcdir)/engine.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS2) $(ENGINE_FLAGS) -DVM_PROFILING -o $@ -c $(srcdir)/engine.c
 
 main.o:		$(MAIN_DEPS) 
-		$(GCC) $(CFLAGS) -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/main.c
 
 main-native.o:	$(MAIN_DEPS) 
-		$(GCC) $(CFLAGS) -DNO_IP -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -DNO_IP -o $@ -c $(srcdir)/main.c
 
 main-fast.o:	$(MAIN_DEPS) 
-		$(GCC) $(CFLAGS) -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -o $@ -c $(srcdir)/main.c
 
 main-itc.o:	$(MAIN_DEPS) 
-		$(GCC) $(CFLAGS) -DINDIRECT_THREADED -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -DINDIRECT_THREADED -DGFORTH_DEBUGGING -o $@ -c $(srcdir)/main.c
 
 main-ditc.o:	$(MAIN_DEPS)
-		$(GCC) $(CFLAGS) -DDOUBLY_INDIRECT -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -DDOUBLY_INDIRECT -o $@ -c $(srcdir)/main.c
 
 main-prof.o:	$(MAIN_DEPS)
-		$(GCC) $(CFLAGS) -DVM_PROFILING -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -DVM_PROFILING -o $@ -c $(srcdir)/main.c
 
 main-fi.o:	$(MAIN_DEPS)
-		$(GCC) $(CFLAGS) -DINCLUDE_IMAGE -o $@ -c $(srcdir)/main.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -DINCLUDE_IMAGE -o $@ -c $(srcdir)/main.c
 
 peephole.o:	peephole.c peephole.i $(DEPS)
-		$(GCC) $(CFLAGS) -o $@ -c $(srcdir)/peephole.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -o $@ -c $(srcdir)/peephole.c
 
 profile.o:	profile.c profile.i $(DEPS)
-		$(GCC) $(CFLAGS) -o $@ -c $(srcdir)/profile.c
+		$(GCC) $(CPPFLAGS)  $(CFLAGS) -o $@ -c $(srcdir)/profile.c
 
 #The next two rules seem to be superfluous:
 