diff -Nurd ikvm-0.42.0.3/native/native.build ikvm-0.42.0.3-patched/native/native.build
--- ikvm-0.42.0.3/native/native.build	2009-06-26 08:53:10.000000000 -0400
+++ ikvm-0.42.0.3-patched/native/native.build	2010-02-19 09:52:34.000000000 -0500
@@ -9,7 +9,7 @@
         </if>
     </target>
     <target name="ikvm-native-unix">
-        <exec program="/bin/bash" commandline="-c 'gcc -o libikvm-native.so --shared -fPIC `pkg-config --cflags --libs gmodule-2.0` jni.c os.c'"/>
+        <exec program="/bin/bash" commandline="-c 'gcc -o libikvm-native.so -bundle -fPIC `pkg-config --cflags --libs gmodule-2.0` jni.c os.c'"/>
         <copy file="libikvm-native.so" todir="../bin"/>
     </target>
     <target name="ikvm-native-win32">
diff -Nurd ikvm-0.42.0.3/openjdk/sun/java2d/pipe/ShapeSpanIterator.java ikvm-0.42.0.3-patched/openjdk/sun/java2d/pipe/ShapeSpanIterator.java
--- ikvm-0.42.0.3/openjdk/sun/java2d/pipe/ShapeSpanIterator.java	2009-05-03 21:13:54.000000000 -0400
+++ ikvm-0.42.0.3-patched/openjdk/sun/java2d/pipe/ShapeSpanIterator.java	2010-02-19 09:52:23.000000000 -0500
@@ -53,25 +53,21 @@
         
     }
 
-    @Override
     public long getNativeIterator(){
         // TODO Auto-generated method stub
         return 0;
     }
 
-    @Override
     public void intersectClipBox(int lox, int loy, int hix, int hiy){
         // TODO Auto-generated method stub
         
     }
 
-    @Override
     public boolean nextSpan(int[] spanbox){
         // TODO Auto-generated method stub
         return false;
     }
 
-    @Override
     public void skipDownTo(int y){
         // TODO Auto-generated method stub
         
diff -Nurd ikvm-0.42.0.3/openjdk/sun/print/Win32PrintService.java ikvm-0.42.0.3-patched/openjdk/sun/print/Win32PrintService.java
--- ikvm-0.42.0.3/openjdk/sun/print/Win32PrintService.java	2009-10-02 20:16:20.000000000 -0400
+++ ikvm-0.42.0.3-patched/openjdk/sun/print/Win32PrintService.java	2010-02-19 09:56:45.000000000 -0500
@@ -45,63 +45,54 @@
     }
 
 
-    @Override
     public void addPrintServiceAttributeListener(PrintServiceAttributeListener listener){
         // TODO Auto-generated method stub
 
     }
 
 
-    @Override
     public DocPrintJob createPrintJob(){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public <T extends PrintServiceAttribute>T getAttribute(Class<T> category){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public PrintServiceAttributeSet getAttributes(){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public Object getDefaultAttributeValue(Class<? extends Attribute> category){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public String getName(){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public ServiceUIFactory getServiceUIFactory(){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public Class<?>[] getSupportedAttributeCategories(){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public Object getSupportedAttributeValues(Class<? extends Attribute> category, DocFlavor flavor,
             AttributeSet attributes){
         // TODO Auto-generated method stub
@@ -109,42 +100,36 @@
     }
 
 
-    @Override
     public DocFlavor[] getSupportedDocFlavors(){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public AttributeSet getUnsupportedAttributes(DocFlavor flavor, AttributeSet attributes){
         // TODO Auto-generated method stub
         return null;
     }
 
 
-    @Override
     public boolean isAttributeCategorySupported(Class<? extends Attribute> category){
         // TODO Auto-generated method stub
         return false;
     }
 
 
-    @Override
     public boolean isAttributeValueSupported(Attribute attrval, DocFlavor flavor, AttributeSet attributes){
         // TODO Auto-generated method stub
         return false;
     }
 
 
-    @Override
     public boolean isDocFlavorSupported(DocFlavor flavor){
         // TODO Auto-generated method stub
         return false;
     }
 
 
-    @Override
     public void removePrintServiceAttributeListener(PrintServiceAttributeListener listener){
         // TODO Auto-generated method stub
 